# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%{!?_mavenpomdir: %global _mavenpomdir %{_datadir}/maven2/poms}

%bcond_with jedit
%bcond_with mono
%bcond_with native
%bcond_without repolib

%global shortname antlr

%global debug_package %{nil}

%define reltag _redhat_2
%define namedreltag -redhat-2
%global namedversion %{version}%{?namedreltag}

Name:           antlr-eap6
Version:        2.7.7
Release:        15%{?reltag}%{?dist}
Epoch:          0
Summary:        ANother Tool for Language Recognition
License:        Public Domain
Group:          Development/Java
URL:            http://www.antlr.org/
Source0:        http://www.antlr2.org/download/antlr-%{version}.tar.gz
Source1:        antlr-build.xml
Source2:        antlr-script
# http://www.antlr.org/share/1069557132934/makefile.gcj
Source3:        makefile.gcj
Source4:        http://repo2.maven.org/maven2/antlr/antlr/2.7.7/antlr-2.7.7.pom
Patch0:         antlr-jedit.patch
Patch1:         antlr-newgcc.patch
Patch2:         antlr-pom.patch
Requires:       jpackage-utils
%if %with native
BuildRequires:  %{_bindir}/gcj
BuildRequires:  %{__make}
%else
BuildArch:      noarch
%endif
BuildRequires:  ant
BuildRequires:  %{__perl}
BuildRequires:  java-javadoc
%if %with repolib
BuildRequires:  jboss-parent
BuildRequires:  maven2-plugin-deploy
%endif
%ifnarch s390 s390x ppc64 sparc64
%if %with mono
BuildRequires:  mono-core
BuildRequires:  mono-winforms
%endif
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
ANTLR, ANother Tool for Language Recognition, (formerly PCCTS) is a
language tool that provides a framework for constructing recognizers,
compilers, and translators from grammatical descriptions containing
C++ or Java actions [You can use PCCTS 1.xx to generate C-based
parsers].

%package -n %{shortname}
Summary:        Java library for reading and editing user input in console applications
Group:          Development/Java
Requires(pre): %{_sbindir}/update-alternatives
Requires(postun): %{_sbindir}/update-alternatives
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils

%description -n %{shortname}
ANTLR, ANother Tool for Language Recognition, (formerly PCCTS) is a
language tool that provides a framework for constructing recognizers,
compilers, and translators from grammatical descriptions containing
C++ or Java actions [You can use PCCTS 1.xx to generate C-based
parsers].

%if %with repolib
%package -n %{shortname}-repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description -n %{shortname}-repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%if %with native
%package -n %{shortname}-native
Group:          Development/Java
Summary:        ANother Tool for Language Recognition (native version)
Requires(pre): %{_sbindir}/update-alternatives
Requires(postun): %{_sbindir}/update-alternatives

%description -n %{shortname}-native
ANTLR, ANother Tool for Language Recognition, (formerly PCCTS) is a
language tool that provides a framework for constructing recognizers,
compilers, and translators from grammatical descriptions containing
C++ or Java actions [You can use PCCTS 1.xx to generate C-based
parsers].  This package includes the native version of the antlr tool.
%endif

%package -n %{shortname}-manual
Group:          Development/Java
Summary:        Manual for %{shortname}

%description -n %{shortname}-manual
Documentation for %{shortname}.

%package -n %{shortname}-javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{shortname}
Requires:       jpackage-utils

%description -n %{shortname}-javadoc
Javadoc for %{shortname}.

%if %with jedit
%package -n %{shortname}-jedit
Group:          Text Editors
Summary:        ANTLR mode for jEdit
Requires:       jedit >= 0:4.1

%description -n %{shortname}-jedit
ANTLR mode for jEdit.  To enable this mode, insert the following into your
%{_datadir}/jedit/modes/catalog:

  <MODE NAME="antlr" FILE="antlr.xml" FILE_NAME_GLOB="*.g"/>
%endif

%prep
%setup -q -n %{shortname}-%{version}
%{_bindir}/find -type f -name '*.jar' | xargs -t rm
%{__perl} -pi -e 's|"doc/|"%{_docdir}/%{name}-manual-%{namedversion}/|g' install.html
%{__perl} -pi -e 's/\r$//' LICENSE.txt

cp -p %{SOURCE1} build.xml
cp -p %{SOURCE4} antlr-%{version}.pom

%if %without native
%patch0 -p1 -b .sav0
%endif
%patch1 -p1 -b .sav1
%patch2 -p1 -b .sav2

%build
export CLASSPATH=
export OPT_JAR_LIST=:
%if %with native
%{__make} -f %{SOURCE3} COMPOPTS="%{optflags}"
%{ant} -Dj2se.apidoc=%{_javadocdir}/java
cp work/lib/antlr.jar .  # make expects to find it here
export CLASSPATH=.
%configure --without-examples
make CXXFLAGS="${CXXFLAGS} -fPIC"
#find . -type f > /tmp/antlr.filelist
# no longer needed
rm antlr.jar
%else
%{ant} -Dj2se.apidoc=%{_javadocdir}/java
%endif

%install
rm -rf %{buildroot}

mkdir -p %{buildroot}%{_bindir}
touch %{buildroot}%{_bindir}/antlr
%if %with native
cp -p cantlr %{buildroot}%{_bindir}/antlr-native
%else
# jars
mkdir -p %{buildroot}%{_javadir}
cp -p work/lib/antlr.jar %{buildroot}%{_javadir}/%{shortname}-%{namedversion}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}.jar; do ln -sf ${jar} `/bin/echo ${jar} | %{__sed} "s|-%{namedversion}||g"`; done)

# Alternative JAR location
mkdir -p %{buildroot}%{_javadir}/%{name}
cp -p work/lib/%{shortname}.jar %{buildroot}%{_javadir}/%{name}/%{shortname}-%{namedversion}.jar
(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{namedversion}.jar; do ln -sf ${jar} `/bin/echo ${jar} | %{__sed} "s|-%{namedversion}||g"`; done)

# pom
mkdir -p %{buildroot}%{_mavenpomdir}
cp -p -p antlr-%{version}.pom %{buildroot}%{_mavenpomdir}/JPP-%{shortname}.pom
%add_to_maven_depmap antlr antlr %{namedversion} JPP %{shortname}
[ %{name} = %{shortname} ] || mv %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/%{shortname}

# script
cp -p %{SOURCE2} %{buildroot}%{_bindir}/antlr-java

%if %with native
# C++ lib and headers, antlr-config
mkdir -p %{buildroot}%{_includedir}/%{shortname}
cp -p lib/cpp/antlr/*.hpp %{buildroot}%{_includedir}/%{shortname}/
mkdir -p %{buildroot}%{_libdir}
cp -p lib/cpp/src/libantlr.a %{buildroot}%{_libdir}/libantlr.a
mkdir -p %{buildroot}%{_bindir}
cp -p scripts/antlr-config %{buildroot}%{_bindir}/antlr-config
%endif

# javadoc
mkdir -p %{buildroot}%{_javadocdir}/%{shortname}-%{namedversion}
cp -pr work/api/* %{buildroot}%{_javadocdir}/%{shortname}-%{namedversion}
ln -s %{shortname}-%{namedversion} %{buildroot}%{_javadocdir}/%{shortname}

# jedit mode
%if %with jedit
mkdir -p %{buildroot}%{_datadir}/jedit/modes
cp -p extras/antlr-jedit.xml %{buildroot}%{_datadir}/jedit/modes/antlr.xml
%endif
%endif

# manual
mkdir -p %{buildroot}%{_docdir}/%{shortname}-%{namedversion}
cp -pr doc/* %{buildroot}%{_docdir}/%{shortname}-%{namedversion}
rm %{buildroot}%{_docdir}/%{shortname}-%{namedversion}/Makefile*

# repolib
%if %with repolib
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export URL=file://%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{_bindir}/mvn-jpp deploy:deploy-file -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
    -DpomFile=%{buildroot}%{_mavenpomdir}/JPP-%{shortname}.pom \
    -Dfile=%{buildroot}%{_javadir}/%{shortname}-%{namedversion}.jar \
    -Durl=${URL}
pushd %{buildroot}%{_javadir}/repository.jboss.com
prevversion=`%{_bindir}/find maven2-brew -type d \( -name '[0-9]*' -a -not -name %{namedversion} \) -print -quit`
[ -z "${prevversion}" ] || prevversion=`/bin/basename ${prevversion}` && for d in `%{_bindir}/find maven2-brew -type d -name ${prevversion}`; do
    %{__mv} ${d}/* `/bin/echo ${d} | %{__sed} -e 's|'${prevversion}'|%{namedversion}|;'`/
    %{__rm} -r ${d}/
done
popd
%endif

%clean
rm -rf %{buildroot}

%pre -n %{shortname}
%{_sbindir}/update-alternatives --install %{_bindir}/antlr antlr %{_bindir}/antlr-java 10

%post -n %{shortname}
%update_maven_depmap

%postun -n %{shortname}
%update_maven_depmap
if [ $1 -eq 0 ] ; then
  %{_sbindir}/update-alternatives --remove antlr %{_bindir}/antlr-java
fi

%if %with native
%pre -n %{shortname}-native
%{_sbindir}/update-alternatives --install %{_bindir}/antlr antlr %{_bindir}/antlr-native 20

%postun -n %{shortname}-native
if [ $1 -eq 0 ] ; then
  %{_sbindir}/update-alternatives --remove %{shortname} %{_bindir}/antlr-native
fi
%endif

%if %with native
%files -n %{shortname}-native
%defattr(0644,root,root,0755)
%doc CHANGES.txt INSTALL.txt LICENSE.txt README.txt
%defattr(0755,root,root,0755)
%ghost %{_bindir}/antlr
%attr(0755,root,root) %{_bindir}/antlr-native
%{_includedir}/%{shortname}
%{_libdir}/libantlr.a
%attr(0755,root,root) %{_bindir}/antlr-config
%else
%files
%defattr(0644,root,root,0755)
%dir %{_javadir}*/%{name}
%{_javadir}*/%{name}/%{shortname}-%{namedversion}.jar
%{_javadir}*/%{name}/%{shortname}.jar

%files -n %{shortname}
%defattr(0644,root,root,0755)
%doc CHANGES.txt INSTALL.txt LICENSE.txt README.txt
%{_javadir}*/%{shortname}-%{namedversion}.jar
%{_javadir}*/%{shortname}.jar
%{_mavenpomdir}/JPP-%{shortname}.pom
%{_mavendepmapfragdir}/%{shortname}
%ghost %{_bindir}/antlr
%attr(0755,root,root) %{_bindir}/antlr-java

%files -n %{shortname}-manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{shortname}-%{namedversion}

%files -n %{shortname}-javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{shortname}-%{namedversion}
%{_javadocdir}/%{shortname}

%if %with jedit
%files -n %{shortname}-jedit
%defattr(0644,root,root,0755)
%{_datadir}/jedit/modes/*
%endif
%endif

%if %with repolib
%files -n %{shortname}-repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Wed Aug 15 2012 Paul Gier <pgier@redhat.com> 0:2.7.7-15
- minor change to pom patch

* Tue Aug 14 2012 David Walluck <dwalluck@redhat.com> 0:2.7.7-14
- main pkg doesn't need jpackage-utils for scriptlets
- remove Makefile's from manual doc

* Tue Aug 14 2012 David Walluck <dwalluck@redhat.com> 0:2.7.7-13
- update-alternatives should be %%pre, not %%post
- fix scriptlet sections for native package
- vman should be patch, not standalone pom
- fix missing requires in the antlr package
- use the correct version on files
- remove double BuildRoot definition
- remove GCJ support
- remove old-style repolib
- remove double native option definition
- fix packaging of native bits
- fix options, especially the native option
- fix build which was building native bits regardless of option
- fix bad deploy command
- add more doc
- fix perms on scripts
- fix maven frag name

* Tue Aug 14 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.7.7-12_redhat_2.2
- Rebuild unsigned

* Thu Jul 19 2012 David Walluck <dwalluck@redhat.com> 0:2.7.7-12
- fix missing default file perms in main pkg
- fix file perms in short name pkg that resulted in many files with 755 perms
- fix dir ownership in repolib pkg
- don't mark javadoc as doc
- fix Release tag

* Thu Jul 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.7.7-10_redhat_1.4.2
- Rebuild using cache signing

* Thu Jul 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.7.7-10_redhat_1.4.1
- Rebuild using cache signing

* Thu Mar 29 2012 Permaine Cheung <pcheung@redhat.com> - 0:2.7.7-10_redhat_1.4
- Move update_maven_depmap to the post and postun section of antlr subpackage

* Wed Mar 28 2012 Martha Benitez <mbenitez@redhat.com> - 0:2.7.7-10_redhat_1.3
- Rebuild with a -eap6 suffix to avoid conflict with RHEL-6 base

* Tue Mar 27 2012 Yong Yang <yyang@redhat.com> - 0:2.7.7-10_redhat_1.2
- Fix pom location in -repolib

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.7.7-10_redhat_1.1
- Rebuild using cache signing

* Mon Feb 06 2012 Yong Yang <yyang@redhat.com> - 0:2.7.7-10_redhat_1
- Fix pom location in -repolib

* Fri Feb 03 2012 Yong Yang <yyang@redhat.com> - 0:2.7.7-9_redhat_1
- Latest vman, resign

* Mon Aug 29 2011 Yong Yang <yyang@redhat.com> - 0:2.7.7-8_redhat_1
- Build for werewolf

* Wed Mar 23 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.7.7-7
- Merge from RHEL6

* Tue Mar 22 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.7.7-1.4
- Rebuild

* Tue Mar 22 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.7.7-1.3
- Rebuild

* Tue Mar 22 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.7.7-1.2
- Rebuild

* Tue Mar 22 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.7.7-1.1
- Add maven2-brew contents to repolib

* Mon Feb 28 2011 David Walluck <dwalluck@redhat.com> 0:2.7.7-1
- 2.7.7

* Sat Jan 09 2010 Will Tatam <will.tatam@red61.com> 0:2.7.6-8
- Auto rebuild for JPackage 6 in centos5 mock

* Mon Nov 02 2009 David Walluck <dwalluck@redhat.com> 0:2.7.6-7
- add maven support

* Mon Apr 13 2009 David Walluck <dwalluck@redhat.com> 0:2.7.6-6
- fix repolib
- fix location of manual
- fix LICENSE.txt eol
- fix macro-in-%%changelog

* Thu Jul 31 2008 David Walluck <dwalluck@redhat.com> 0:2.7.6-5
- fix Release
- update BuildRoot
- remove javadoc scriptlets
- GCJ fixes
- fix permissions
- fix repolib permissions

* Tue May 27 2008 Permaine Cheung <pcheung@redhat.com> - 0:2.7.6-4jpp
- First JPP5 build

* Tue Mar 13 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:2.7.6-3jpp.ep1.2
- Fix typo in repodir

* Tue Mar 13 2007 Fernando Nasser <fnasser@redhat.com> - 0:2.7.6-3jpp.ep1.1
- New repolib location

* Mon Feb 19 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:2.7.6-3jpp.el4ep1.2
- Use -brew suffix

* Thu Feb 15 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:2.7.6-3jpp.el4ep1.1
- Repolib support added

* Wed Aug 02 2006 Fernando Nasser <fnasser@redhat.com> - 0:2.7.6-3jpp_1rh
- Merge with upstream

* Wed Jul 19 2006 Deepak Bhole <dbhole@redhat.om> = 0:2.7.6-3jpp
- Added conditional native compilation.

* Fri Jan 13 2006 Fernando Nasser <fnasser@redhat.com> - 0:2.7.6-2jpp_1rh
- Merge with upstream for upgrade

* Fri Jan 13 2006 Fernando Nasser <fnasser@redhat.com> - 0:2.7.6-2jpp
- First JPP 1.7 build

* Fri Jan 13 2006 Fernando Nasser <fnasser@redhat.com> - 0:2.7.6-1jpp
- Update to 2.7.6.

* Mon Nov 15 2004 Fernando Nasser <fnasser@redhat.com> - 0:2.7.4-2jpp_1rh
- Merge with upstream for upgrade

* Fri Aug 20 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.7.4-2jpp
- Build with ant-1.6.2.
- Made native scripts conditional

* Tue May 18 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:2.7.4-1jpp
- Update to 2.7.4.

* Fri Apr  2 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:2.7.3-2jpp
- Create alternatives also on upgrades.

* Wed Mar 31 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:2.7.3-1jpp
- Update to 2.7.3.
- Include gcj build option and a native subpackage, build using
  "--with native" to get that.
- Add %%{_bindir}/antlr alternative.

* Thu Mar  4 2004 Frank Ch. Eigler <fche@redhat.com - 0:2.7.2-3jpp_1rh
- RH vacuuming

* Mon Dec 15 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:2.7.2-3jpp
- Add non-versioned javadoc dir symlink.
- Crosslink with local J2SE javadocs.
- Spec cleanups, change to UTF-8.

* Sun Mar 30 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:2.7.2-2jpp
- Rebuild for JPackage 1.5.

* Sat Mar  1 2003 Ville Skyttä <ville.skytta at iki.fi> - 2.7.2-1jpp
- Update to 2.7.2.
- Include antlr script and jEdit mode (see antlr-jedit RPM description).
- Use sed instead of bash 2 extension when symlinking jars during build.

* Tue May 07 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.7.1-8jpp
- really section macro
- hardcoded distribution and vendor tag
- group tag again

* Thu May 2 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.7.1-7jpp
- distribution tag
- group tag
- section macro

* Fri Jan 18 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.7.1-6jpp
- versioned dir for javadoc
- no dependencies for manual and javadoc packages
- additional sources in individual archives

* Sat Dec 1 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.7.1-5jpp
- javadoc in javadoc package

* Wed Nov 21 2001 Christian Zoffoli <czoffoli@littlepenguin.org> 2.7.1-4jpp
- removed packager tag
- new jpp extension

* Sat Oct 6 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.7.1-3jpp
- used a build file instead of makefile
- build classes instead of blindly jared them !
- used original tarball
- corrected license spelling

* Sun Sep 30 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.7.1-2jpp
- first unified release
- s/jPackage/JPackage

* Tue Aug 28 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.7.1-1mdk
- first Mandrake release
